<?php

// подключим все необходимые файлы:
require_once $_SERVER["DOCUMENT_ROOT"] .
	"/bitrix/modules/main/include/prolog_admin_before.php"; // первый общий пролог
require_once $_SERVER["DOCUMENT_ROOT"] .
	"/bitrix/modules/subscribe/include.php"; // инициализация модуля
require_once $_SERVER["DOCUMENT_ROOT"] . "/bitrix/modules/subscribe/prolog.php"; // пролог модуля

// подключим языковой файл
IncludeModuleLangFile(__FILE__);

// получим права доступа текущего поль
$APPLICATION->SetTitle(GetMessage('BIFIT_REPORTS_TITLE'));

if (!CModule::IncludeModule("bifit.kassa")) {
	ShowError(GetMessage('BIFIT_REPORTS_MODULE_INCLUDE_ERROR'));
	require $_SERVER["DOCUMENT_ROOT"] .
		"/bitrix/modules/main/include/epilog_admin.php";
}

$sTableID = "b_bifit_kassa_reports"; // ID таблицы
$oSort = new CAdminSorting($sTableID, "ID", "desc"); // объект сортировки
$lAdmin = new CAdminList($sTableID, $oSort); // основной объект списка
CUtil::InitJSCore(array('ajax', 'jquery', 'popup'));

// ******************************************************************** //
//                ОБРАБОТКА ДЕЙСТВИЙ НАД ЭЛЕМЕНТАМИ СПИСКА              //
// ******************************************************************** //
// обработка одиночных и групповых действий
if ($arID = $lAdmin->GroupAction()) {
	// если выбрано "Для всех элементов"
	if ($_REQUEST['action_target'] == 'selected') {
		$cData = new BifitKassaReportsTable();
		$rsData = $cData->GetList(
			array(
				$by => $order
			),
			$arFilter
		);

		while ($arRes = $rsData->Fetch()) {
			$arID[] = $arRes['ID'];
		}
	}

	// пройдем по списку элементов
	foreach ($arID as $ID) {
		if (strlen($ID) <= 0) {
			continue;
		}

		$ID = IntVal($ID);

		// для каждого элемента совершим требуемое действие
		switch ($_REQUEST['action']) {
			// удаление
			case "delete":
				@set_time_limit(0);
				$DB->StartTransaction();

				if (!BifitKassaReportsTable::Delete($ID)) {
					$DB->Rollback();
					$lAdmin->AddGroupError(GetMessage("rub_del_err"), $ID);
				}

				$DB->Commit();
				break;
		}
	}
}

// ******************************************************************** //
//                ВЫБОРКА ЭЛЕМЕНТОВ СПИСКА                              //
// ******************************************************************** //
$rsData = BifitKassaReportsTable::getList(array(
	'order' => array(
		'ID' => 'DESC'
	),
	'offset' => $offset,
	'limit' => $limit
));

// преобразуем список в экземпляр класса CAdminResult
$rsData = new CAdminResult($rsData, $sTableID);

// аналогично CDBResult инициализируем постраничную навигацию
$rsData->NavStart();

// отправим вывод переключателя страниц в основной объект $lAdmin
$lAdmin->NavText($rsData->GetNavPrint(GetMessage("rub_nav")));

// ******************************************************************** //
//                ПОДГОТОВКА СПИСКА К ВЫВОДУ                            //
// ******************************************************************** //
$lAdmin->AddHeaders(array(
	array(
		"id" => 'id',
		"content" => GetMessage('BIFIT_REPORTS_ITEM_ID'),
		"default" => true
	),
	array(
		"id" => 'order_id',
		"content" => GetMessage('BIFIT_REPORTS_ITEM_ORDER_ID'),
		"default" => true
	),
	array(
		"id" => 'order_number',
		"content" => GetMessage('BIFIT_REPORTS_ITEM_ORDER_NUMBER'),
		"default" => true
	),
	array(
		"id" => 'order_date',
		"content" => GetMessage('BIFIT_ORDER_DATE'),
		"default" => true
	),
	array(
		"id" => 'action_date',
		"content" => GetMessage('BIFIT_ACTION_DATE'),
		"default" => true
	),
	array(
		"id" => 'receipt_link',
		"content" => GetMessage('BIFIT_RECEIPT'),
		"default" => true
	),
	array(
		"id" => 'doc',
		"content" => GetMessage('BIFIT_DOCUMENT'),
		"default" => true
	),
	array(
		"id" => 'log',
		"content" => GetMessage('BIFIT_LOG'),
		"default" => true
	),
	array(
		"id" => 'receipt_type',
		"content" => GetMessage('BIFIT_TYPE'),
		"default" => true
	)
));

while ($arRes = $rsData->NavNext(true)) {
	// создаем строку. результат - экземпляр класса CAdminListRow
	$row = &$lAdmin->AddRow($arRes['ID'], array(
		'id' => $arRes['ID'],
		'order_id' => $arRes['ORDER_ID'],
		'order_number' => $arRes['ORDER_NUMBER'],
		'order_date' => $arRes['ORDER_DATE'],
		'action_date' => $arRes['ACTION_DATE'],
		'receipt_link' => $arRes['RECEIPT_LINK'],
		'receipt_id' => $arRes['RECEIPT_ID'],
		'log' => $arRes['LOG'],
		'receipt_type' => $arRes['RECEIPT_TYPE']
	));

	$text_log =
		'<div style="width:600px;overflow-y:scroll">' .
		str_replace("\n", "<br>", $arRes['LOG']) .
		"</div>";

	// далее настроим отображение значений при просмотре и редаткировании списка
	// параметр NAME будет редактироваться как текст, а отображаться ссылкой
	$row->AddInputField("order_id", array("size" => 20));
	$row->AddViewField(
		"order_id",
		'<a target="_blank" class="bifit_edit_btn adm-btn" href="/bitrix/admin/sale_order_view.php?ID=' .
			$arRes['ORDER_ID'] .
			'&lang=ru&filter=Y&set_filter=Y" title="' .
			GetMessage('BIFIT_CHANGE_ORDER_PARAMS') .
			'">№' .
			$arRes['ORDER_ID'] .
			'</a>'
	);
	$row->AddViewField(
		"order_number",
		'№' . $arRes['ORDER_NUMBER']
	);
	$row->AddInputField("receipt_link", array("size" => 20));
	$row->AddViewField(
		"receipt_link",
		$arRes['RECEIPT_ID'] > 0
			? '<a target="_blank" class="bifit_update_btn adm-btn" href="' .
				$arRes['RECEIPT_LINK'] .
				'">' .
				GetMessage('BIFIT_OPEN') .
				'</a>'
			: '<span class="error">' . GetMessage('BIFIT_NONE_SM') . '</span>'
	);
	$row->AddInputField("doc", array("size" => 20));
	$row->AddViewField(
		"doc",
		$arRes['RECEIPT_ID'] > 0
			? '<span class="success">' . $arRes['RECEIPT_ID'] . '</span>'
			: '<span class="error">' . GetMessage('BIFIT_NONE_SM') . '</span>'
	);

	$row->AddInputField("log", array("size" => 20));
	$row->AddViewField(
		"log",
		'
<a id="showlog' .
			$arRes['ID'] .
			'" class="bifit_update_btn adm-btn" href="#log' .
			$arRes['ID'] .
			'">' .
			GetMessage('BIFIT_VIEW') .
			'</a>
<script type="text/javascript">
var addlog' .
			$arRes['ID'] .
			' = new BX.PopupWindow(
	"addlog' .
			$arRes['ID'] .
			'",
	null, 
	{
		content: \'' .
			addslashes($text_log) .
			'\',
		closeIcon: {
			right: "20px", 
			top: "10px"
		},
		titleBar: {
			content: BX.create("h3", {
				html: "' .
			GetMessage('BIFIT_LOG') .
			'", \'props\': {\'className\': \'access-title-bar\'}
			})
		}, 
		zIndex: 0,
		offsetLeft: 0,
		offsetTop: 0,
		draggable: {
			restrict: false
		},
		buttons: [
			new BX.PopupWindowButton({
				text: "Закрыть",
				className: "webform-button-link-cancel",
				events: {
					click: function() {
						this.popupWindow.close();
					}
				}
			})
		]
	}
);
$(\'#showlog' .
			$arRes['ID'] .
			'\').click(function() {            
	addlog' .
			$arRes['ID'] .
			'.show(); // появление окна
});
</script>'
	);

	$row->AddViewField(
		"receipt_type",
		'<span class="type ' .
			($arRes['RECEIPT_ID'] > 0 ? 'type-success ' : 'type-error ') .
			'type-' .
			strtolower($arRes['RECEIPT_TYPE']) .
			'">' .
			GetMessage('BIFIT_TYPE_' . $arRes['RECEIPT_TYPE']) .
			'</span>'
	);
}

// резюме таблицы
$lAdmin->AddFooter(array(
	array(
		"title" => GetMessage("MAIN_ADMIN_LIST_SELECTED"),
		"value" => $rsData->SelectedRowsCount()
	), // кол-во элементов
	array(
		"counter" => true,
		"title" => GetMessage("MAIN_ADMIN_LIST_CHECKED"),
		"value" => "0"
	) // счетчик выбранных элементов
));

// групповые действия
$lAdmin->AddGroupActionTable(array(
	"delete" => GetMessage("MAIN_ADMIN_LIST_DELETE") // удалить выбранные элементы
));

// альтернативный вывод
$lAdmin->CheckListMode();

// не забудем разделить подготовку данных и вывод
require $_SERVER["DOCUMENT_ROOT"] .
	"/bitrix/modules/main/include/prolog_admin_after.php";

// выведем таблицу списка элементов
$lAdmin->DisplayList();

echo '<style type="text/css">table#b_bifit_kassa_reports tr td:nth-child(1),table#b_bifit_kassa_reports tr td:nth-child(2),table#b_bifit_kassa_reports tr td:nth-child(3),table#b_bifit_kassa_reports tr td:nth-child(4),table#b_bifit_kassa_reports tr td:nth-child(7),table#b_bifit_kassa_reports tr td:nth-child(8),table#b_bifit_kassa_reports tr td:nth-child(9),table#b_bifit_kassa_reports tr td:nth-child(10){padding:11px 5px 10px;text-align:center}table#b_bifit_kassa_reports thead tr td{white-space:nowrap}table#b_bifit_kassa_reports tbody tr td.adm-list-table-cell{vertical-align:middle}table#b_bifit_kassa_reports tbody tr td:nth-child(4){color:#1c53a2}a.bifit_update_btn{color:#3f4b54!important}span.error{font-weight:700;letter-spacing:.1em;color:red}span.success{font-weight:700;letter-spacing:.1em;color:forestgreen}span.type{padding:4px 10px;border-radius:4px;color:white;background:green}span.type-error{opacity:.5}span.type.type-sale{background:forestgreen;color:white}span.type.type-sale_return{background:lightgreen;color:black}span.type.type-purchase{background:lightslategrey;color:white}span.type.type-purchase_return{background:lightslateblue;color:black}</style>';

// завершение страницы
require $_SERVER["DOCUMENT_ROOT"] .
	"/bitrix/modules/main/include/epilog_admin.php";